"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var STOP = Symbol('Progressive.stop');
var Progressive = (function () {
    function Progressive(handler) {
        this._rate = 0;
        this._handler = handler;
    }
    Progressive.prototype.start = function (duration) {
        return __awaiter(this, void 0, void 0, function () {
            var initRate, _a, e_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this._startTimestamp = Date.now();
                        initRate = this._rate;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 5, , 6]);
                        _b.label = 2;
                    case 2:
                        if (!(this._rate < 1)) return [3 /*break*/, 4];
                        _a = this;
                        return [4 /*yield*/, this._progress(initRate, duration)];
                    case 3:
                        _a._rate = _b.sent();
                        return [3 /*break*/, 2];
                    case 4: return [2 /*return*/, Promise.resolve()];
                    case 5:
                        e_1 = _b.sent();
                        if (e_1 === STOP) {
                            return [2 /*return*/, Promise.resolve()];
                        }
                        throw e_1;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    Progressive.prototype.pause = function () {
        if (this._pause) {
            cancelAnimationFrame(this._rafId);
            this._pause();
        }
    };
    Progressive.prototype.stop = function () {
        if (this._pause) {
            this.pause();
            this._rate = 0;
            this._handler(0);
        }
    };
    Progressive.prototype._progress = function (initRate, duration) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this._pause = function () { return reject(STOP); };
            _this._rafId = requestAnimationFrame(function () {
                var period = Date.now() - _this._startTimestamp;
                var rate = Math.min(period / duration + initRate, 1);
                _this._handler(rate);
                resolve(rate);
            });
        });
    };
    return Progressive;
}());
exports.default = Progressive;
